## osm2pgsql 2.0.1+ds

=== CMakeLists.txt ===

cmake_minimum_required(VERSION 3.8.0)

project(osm2pgsql VERSION 2.0.1 LANGUAGES CXX C)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

# Do not create install targets when run as a subproject.
# Currently used by Nominatim which cannot yet rely on installed versions
# of osm2pgsql.
if (${PROJECT_NAME} STREQUAL ${CMAKE_PROJECT_NAME})
    set(ENABLE_INSTALL ON)
else()
    set(ENABLE_INSTALL OFF)
endif()

if (NOT ${CMAKE_SIZEOF_VOID_P} EQUAL 8)
    message(FATAL_ERROR "osm2pgsql needs a 64 bit architecture")
endif()

if (WIN32)
    set(DEFAULT_STYLE "default.style" CACHE STRING "Default style used unless one is given on the command line")
else()
    set(DEFAULT_STYLE "${CMAKE_INSTALL_PREFIX}/share/osm2pgsql/default.style" CACHE STRING "Default style used unless one is given on the command line")
endif()

option(BUILD_TESTS    "Build test suite" OFF)
option(BUILD_COVERAGE "Build with coverage" OFF)
option(WITH_LUAJIT    "Build with LuaJIT support" OFF)
option(WITH_PROJ      "Build with Projection support" ON)

if (PROJECT_SOURCE_DIR STREQUAL PROJECT_BINARY_DIR)
    message(FATAL_ERROR "In-source builds are not allowed, please use a separate build directory like `mkdir build && cd build && cmake ..`")
endif()

message(STATUS "Building osm2pgsql ${PROJECT_VERSION}")

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

# We don't want to use special compiler extensions because we want portability
set(CMAKE_CXX_EXTENSIONS OFF)

if (MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS -DNOMINMAX)
    add_compile_options(-wd4996 -utf-8)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /ignore:4099")
else()
    add_compile_options(-Wall)
endif()

option(EXTERNAL_LIBOSMIUM "Do not use the bundled libosmium" OFF)
option(EXTERNAL_PROTOZERO "Do not use the bundled protozero" OFF)
option(EXTERNAL_FMT       "Do not use the bundled fmt"       OFF)
option(EXTERNAL_CLI11     "Do not use the bundled CLI11"     OFF)

if (NOT WIN32 AND NOT APPLE)
    # No need for this path, just a workaround to make cmake work on all systems.
    # Without this we need the PostgreSQL server libraries installed.
    # https://stackoverflow.com/questions/13920383/findpostgresql-cmake-wont-work-on-ubuntu
    set(PostgreSQL_TYPE_INCLUDE_DIR /usr/include)
endif()

set(MINIMUM_POSTGRESQL_SERVER_VERSION "9.6")
set(MINIMUM_POSTGRESQL_SERVER_VERSION_NUM "90600")

set(PostgreSQL_ADDITIONAL_VERSIONS "17" "16" "15" "14" "13" "12" "11" "10" "9.6")

#############################################################
# Version
#############################################################

find_package(Git)

if (GIT_FOUND)
    execute_process(COMMAND "${GIT_EXECUTABLE}" describe --tags --dirty=-changed
                    WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
                    OUTPUT_VARIABLE VERSION_FROM_GIT
                    ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
    if (VERSION_FROM_GIT)
        set(VERSION_FROM_GIT " (${VERSION_FROM_GIT})")
    endif()
endif()

configure_file(
    ${PROJECT_SOURCE_DIR}/src/version.cpp.in
    ${PROJECT_BINARY_DIR}/src/version.cpp
)

#############################################################
# Coverage
#############################################################

if (BUILD_COVERAGE)
    if (NOT BUILD_TESTS)
        message(WARNING "Coverage build enabled, but tests not enabled!")
    endif()

    if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
        string(REGEX REPLACE "^([0-9]+).*$" "llvm-cov-\\1"
               gcov_ ${CMAKE_CXX_COMPILER_VERSION})
        set(gcov_param_ " gcov")
    else()
        set(gcov_ "gcov")
        set(gcov_param_ "")
    endif()

    message(STATUS "Looking for coverage tool: ${gcov_}")

    find_program(GCOV ${gcov_} DOC "Coverage tool")

    if (GCOV STREQUAL "GCOV-NOTFOUND")
        message(STATUS "  coverage tool not found - coverage disabled")
    else()
        message(STATUS "  found")

        message(STATUS "Looking von gcovr")
        find_program(GCOVR "gcovr" DOC "Coverage report tool")
        if (GCOVR STREQUAL "GCOVR-NOTFOUND")
            message(WARNING "  gcovr not found - coverage will not work")
        else()
            message(STATUS "  found")
        endif()

        add_compile_options(-g -O0 -fno-inline-functions -fno-inline --coverage)

        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} --coverage"
            CACHE
            STRING "Flags used by the linker during all build types."
            FORCE)

        set(coverage_report_dir "${CMAKE_BINARY_DIR}/coverage")
        file(MAKE_DIRECTORY ${coverage_report_dir})
        add_custom_target(coverage
            ${GCOVR}
            ${CMAKE_BINARY_DIR}
            --root=${CMAKE_SOURCE_DIR}
            --html-details
            --html-title "osm2pgsql coverage report"
            #--verbose
            #--keep
            --delete
            '--exclude=.*contrib.*'
            --sort-percentage
            --gcov-executable=${GCOV}${gcov_param_}
            --output=${coverage_report_dir}/index.html)
    endif()
endif()

#############################################################
# Detect available headers and set global compiler options
#############################################################

include(CheckIncludeFiles)

add_definitions(-DDEFAULT_STYLE=\"${DEFAULT_STYLE}\")

#############################################################
# Find necessary libraries
#############################################################

if (NOT EXTERNAL_LIBOSMIUM)
    set(OSMIUM_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/contrib/libosmium/include")
endif()

if (NOT EXTERNAL_PROTOZERO)
    set(PROTOZERO_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/contrib/protozero/include")
endif()

if (NOT EXTERNAL_FMT)
    set(FMT_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/contrib/fmt/include")
endif()

if (NOT EXTERNAL_CLI11)
    set(CLI11_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/contrib/CLI11/include")
endif()

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src ${CMAKE_CURRENT_BINARY_DIR})

find_package(Osmium 2.17.3 REQUIRED COMPONENTS io)
include_directories(SYSTEM ${OSMIUM_INCLUDE_DIRS} ${PROTOZERO_INCLUDE_DIR} ${FMT_INCLUDE_DIR} ${CLI11_INCLUDE_DIR})

if (WITH_LUAJIT)
    message(STATUS "Building with LuaJIT support")
    find_package(LuaJIT REQUIRED)
    include_directories(SYSTEM ${LUAJIT_INCLUDE_DIR})
    add_definitions(-DHAVE_LUAJIT=1)
else()
    message(STATUS "Building with Lua (but not LuaJIT) support")
    find_package(Lua REQUIRED)
    include_directories(SYSTEM ${LUA_INCLUDE_DIR})
endif()

find_program(LUA_EXE NAMES lua lua5.4 lua5.3 lua5.2 lua5.1)

find_package(Boost 1.50 REQUIRED)
include_directories(SYSTEM ${Boost_INCLUDE_DIR})

find_package(PostgreSQL REQUIRED)
include_directories(SYSTEM ${PostgreSQL_INCLUDE_DIRS})

find_package(Threads)

find_path(NLOHMANN_INCLUDE_DIR nlohmann/json.hpp)
include_directories(SYSTEM ${NLOHMANN_INCLUDE_DIR})

find_path(POTRACE_INCLUDE_DIR potracelib.h)
find_library(POTRACE_LIBRARY NAMES potrace)

find_package(OpenCV QUIET OPTIONAL_COMPONENTS core imgcodecs imgproc)

############### Libraries are found now ########################

set(LIBS ${Boost_LIBRARIES} ${PostgreSQL_LIBRARY} ${OSMIUM_LIBRARIES})

if (WITH_PROJ)
    find_path(PROJ6_INCLUDE_DIR proj.h)
    find_library(PROJ_LIBRARY NAMES proj)
    if (PROJ_LIBRARY)
        message(STATUS "Found Proj ${PROJ_LIBRARY}")
        add_definitions(-DHAVE_GENERIC_PROJ=6)
        set(HAVE_PROJ6 1)
        list(APPEND LIBS ${PROJ_LIBRARY})
        include_directories(SYSTEM ${PROJ6_INCLUDE_DIR})
    endif()
endif()

if (LUAJIT_FOUND)
    list(APPEND LIBS ${LUAJIT_LIBRARIES})
else()
    list(APPEND LIBS ${LUA_LIBRARIES})
endif()

if (WIN32)
    list(APPEND LIBS ws2_32)
endif()

message(STATUS "Libraries used to build: ${LIBS}")

#############################################################
# Build the library and executable file
#############################################################

add_subdirectory(src)

add_executable(osm2pgsql src/osm2pgsql.cpp)
target_link_libraries(osm2pgsql osm2pgsql_lib ${LIBS})

if (${POTRACE_LIBRARY} STREQUAL "POTRACE_LIBRARY-NOTFOUND" OR NOT OPENCV_CORE_FOUND)
    message(STATUS "Did not find opencv and/or potrace library. Not building osm2pgsql-gen.")
else()
    message(STATUS "Found opencv and potrace library. Building osm2pgsql-gen.")
    set(BUILD_GEN 1)
    include_directories(SYSTEM ${POTRACE_INCLUDE_DIR})
    add_executable(osm2pgsql-gen src/gen/osm2pgsql-gen.cpp
                src/gen/canvas.cpp
                src/gen/gen-base.cpp
                src/gen/gen-create.cpp
                src/gen/gen-discrete-isolation.cpp
                src/gen/gen-rivers.cpp
                src/gen/gen-tile-builtup.cpp
                src/gen/gen-tile-raster.cpp
                src/gen/gen-tile-sql.cpp
                src/gen/gen-tile-vector.cpp
                src/gen/gen-tile.cpp
                src/gen/params.cpp
                src/gen/raster.cpp
                src/gen/tracer.cpp)
    target_link_libraries(osm2pgsql-gen osm2pgsql_lib ${LIBS} ${POTRACE_LIBRARY} ${OpenCV_LIBS})
endif()

#############################################################
# Optional "clang-tidy" target
#############################################################

message(STATUS "Looking for clang-tidy")
find_program(CLANG_TIDY
             NAMES clang-tidy clang-tidy-19 clang-tidy-18 clang-tidy-17 clang-tidy-16 clang-tidy-15)

if (CLANG_TIDY)
    message(STATUS "Looking for clang-tidy - found ${CLANG_TIDY}")

    file(GLOB CT_CHECK_FILES src/*.cpp src/*/*.cpp tests/*cpp)

    add_custom_target(clang-tidy
        ${CLANG_TIDY}
        -p ${CMAKE_BINARY_DIR}
        ${CT_CHECK_FILES}
    )
else()
    message(STATUS "Looking for clang-tidy - not found")
    message(STATUS "  Build target 'clang-tidy' will not be available.")
endif()

#############################################################
# Build tests
#############################################################

if (BUILD_TESTS)
    enable_testing()
    if (NOT TESTING_TIMEOUT)
        set(TESTING_TIMEOUT 1200)
    endif()
    add_subdirectory(tests)
    configure_file(
        ${PROJECT_SOURCE_DIR}/tests/run-behave.in
        ${PROJECT_BINARY_DIR}/run-behave
    )
else()
    message(STATUS "Tests disabled. Set BUILD_TESTS=ON to enable tests.")
endif()

#############################################################
# Man page
#############################################################

add_subdirectory(man)

#############################################################
# Install
#############################################################

include(GNUInstallDirs)

if (ENABLE_INSTALL)
    install(TARGETS osm2pgsql DESTINATION bin)
    install(FILES default.style empty.style DESTINATION share/osm2pgsql)
    install(PROGRAMS scripts/osm2pgsql-replication DESTINATION bin)
    if (BUILD_GEN)
        install(TARGETS osm2pgsql-gen DESTINATION bin)
    endif()
endif()

=== src/CMakeLists.txt ===

add_library(osm2pgsql_lib STATIC)

# Set the minimum required C++ version for the library and hence for all
# binaries that use it.
target_compile_features(osm2pgsql_lib PUBLIC cxx_std_17)

set_property(DIRECTORY APPEND PROPERTY CMAKE_CONFIGURE_DEPENDS
                "${CMAKE_CURRENT_SOURCE_DIR}/init.lua")
file(READ "${CMAKE_CURRENT_SOURCE_DIR}/init.lua" LUA_INIT_CODE)
configure_file(lua-init.cpp.in lua-init.cpp @ONLY)

target_sources(osm2pgsql_lib PRIVATE
    command-line-app.cpp
    command-line-parser.cpp
    db-copy.cpp
    debug-output.cpp
    expire-output.cpp
    expire-tiles.cpp
    flex-index.cpp
    flex-lua-expire-output.cpp
    flex-lua-geom.cpp
    flex-lua-index.cpp
    flex-lua-table.cpp
    flex-table-column.cpp
    flex-table.cpp
    flex-write.cpp
    geom-area-assembler.cpp
    geom-box.cpp
    geom-from-osm.cpp
    geom-functions.cpp
    geom-pole-of-inaccessibility.cpp
    geom.cpp
    idlist.cpp
    input.cpp
    logging.cpp
    lua-setup.cpp
    lua-utils.cpp
    middle-pgsql.cpp
    middle-ram.cpp
    middle.cpp
    node-locations.cpp
    node-persistent-cache.cpp
    ordered-index.cpp
    osmdata.cpp
    output-flex.cpp
    output-null.cpp
    output-pgsql.cpp
    output.cpp
    pgsql-capabilities.cpp
    pgsql-helper.cpp
    pgsql.cpp
    progress-display.cpp
    properties.cpp
    reprojection.cpp
    table.cpp
    taginfo.cpp
    tagtransform-c.cpp
    tagtransform-lua.cpp
    tagtransform.cpp
    thread-pool.cpp
    tile.cpp
    util.cpp
    wildcmp.cpp
    wkb.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/lua-init.cpp
    ${PROJECT_BINARY_DIR}/src/version.cpp
)

if (HAVE_PROJ6)
    target_sources(osm2pgsql_lib PRIVATE reprojection-generic-proj6.cpp)
else()
    target_sources(osm2pgsql_lib PRIVATE reprojection-generic-none.cpp)
endif()

set_target_properties(osm2pgsql_lib PROPERTIES OUTPUT_NAME osm2pgsql)
target_link_libraries(osm2pgsql_lib ${LIBS})

=== tests/CMakeLists.txt ===
# Add a new test
#
# set_test(name [LABELS labels])
#
# name - Name of test (source file without suffix)
# labels - optional labels for the test
function(set_test test_name)
    cmake_parse_arguments(test_param "" "" "LABELS" ${ARGN})

    add_executable(${test_name} ${test_name}.cpp)
    target_link_libraries(${test_name} osm2pgsql_lib catch_main_lib)
    add_test(NAME ${test_name} COMMAND ${test_name})

    set_tests_properties(${test_name} PROPERTIES TIMEOUT ${TESTING_TIMEOUT})

    if (DEFINED test_param_LABELS)
        list(FIND test_param_LABELS Tablespace test_num_labels)
        if (${test_num_labels} EQUAL -1)
            list(APPEND test_param_LABELS "NoTablespace")
        else()
            set_tests_properties(${test_name}
                                 PROPERTIES FIXTURES_REQUIRED Tablespace)
        endif()

        set_tests_properties(${test_name} PROPERTIES LABELS "${test_param_LABELS}")
    else()
        set_tests_properties(${test_name} PROPERTIES LABELS NoTablespace)
    endif()

    message(STATUS "Added test: ${test_name}...")
endfunction()

include_directories(SYSTEM "${CMAKE_CURRENT_SOURCE_DIR}/../contrib/catch2/include")

add_definitions(-DTESTDATA_DIR=\"${osm2pgsql_SOURCE_DIR}/tests/data/\")
add_definitions(-DOSM2PGSQLDATA_DIR=\"${osm2pgsql_SOURCE_DIR}/\")

add_library(catch_main_lib STATIC catch-main.cpp)
target_compile_features(catch_main_lib PUBLIC cxx_std_17)

set_test(test-check-input LABELS NoDB)
set_test(test-db-copy-mgr)
set_test(test-db-copy-thread)
set_test(test-domain-matcher LABELS NoDB)
set_test(test-expire-from-geometry LABELS NoDB)
set_test(test-expire-tiles LABELS NoDB)
set_test(test-flex-indexes)
set_test(test-geom-box LABELS NoDB)
set_test(test-geom-collections LABELS NoDB)
set_test(test-geom-linestrings LABELS NoDB)
set_test(test-geom-multilinestrings LABELS NoDB)
set_test(test-geom-multipoints LABELS NoDB)
set_test(test-geom-multipolygons LABELS NoDB)
set_test(test-geom-null LABELS NoDB)
set_test(test-geom-output LABELS NoDB)
set_test(test-geom-points LABELS NoDB)
set_test(test-geom-pole-of-inaccessibility LABELS NoDB)
set_test(test-geom-polygons LABELS NoDB)
set_test(test-geom-transform LABELS NoDB)
set_test(test-json-writer LABELS NoDB)
set_test(test-lua-utils)
set_test(test-middle)
set_test(test-node-locations LABELS NoDB)
set_test(test-options-parse LABELS NoDB)
set_test(test-options-projection)
set_test(test-ordered-index LABELS NoDB)
set_test(test-osm-file-parsing LABELS NoDB)
set_test(test-output-flex)
set_test(test-output-flex-multi-input)
set_test(test-output-flex-nodes)
set_test(test-output-flex-relation-combinations)
set_test(test-output-flex-relations)
set_test(test-output-flex-schema)
set_test(test-output-flex-stage2)
set_test(test-output-flex-tablespace LABELS Tablespace)
set_test(test-output-flex-types)
set_test(test-output-flex-uni)
set_test(test-output-flex-update)
set_test(test-output-flex-validgeom)
set_test(test-output-pgsql)
set_test(test-output-pgsql-area)
set_test(test-output-pgsql-hstore-match-only)
set_test(test-output-pgsql-int4)
set_test(test-output-pgsql-schema)
set_test(test-output-pgsql-style-file)
set_test(test-output-pgsql-tablespace LABELS Tablespace)
set_test(test-output-pgsql-validgeom)
set_test(test-output-pgsql-z_order)
set_test(test-persistent-cache LABELS NoDB)
set_test(test-pgsql)
set_test(test-pgsql-capabilities)
set_test(test-properties)
set_test(test-reprojection LABELS NoDB)
set_test(test-taginfo LABELS NoDB)
set_test(test-tile LABELS NoDB)
set_test(test-util LABELS NoDB)
set_test(test-wildcard-match LABELS NoDB)
set_test(test-wkb LABELS NoDB)

set_test(test-output-flex-example-configs)
set(FLEX_EXAMPLE_CONFIGS "addresses,attributes,bbox,compatible,data-types,expire,generic,geometries,indexes,places,route-relations,simple,unitable")
# with-schema.lua is not tested because it needs the schema created in the database
set_tests_properties(test-output-flex-example-configs PROPERTIES ENVIRONMENT "EXAMPLE_FILES=${FLEX_EXAMPLE_CONFIGS}")

# Fixture for creating test tablespace under a pg_virtualenv
if (NOT WIN32)
    message(STATUS "Added tablespace fixture...")
    add_test(NAME FixtureTablespaceSetup
             COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/fixture-tablespace-setup
             WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    add_test(NAME FixtureTablespaceCleanup
             COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/fixture-tablespace-cleanup
             WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

    set_tests_properties(FixtureTablespaceSetup PROPERTIES FIXTURES_SETUP Tablespace)
    set_tests_properties(FixtureTablespaceCleanup PROPERTIES FIXTURES_CLEANUP Tablespace)
endif()


find_program(BEHAVE_BIN NAMES behave)

if (BEHAVE_BIN)
    foreach(BDD_TEST IN ITEMS command-line flex regression)
        add_test(NAME bdd-${BDD_TEST}
                 COMMAND behave -DBINARY=$<TARGET_FILE:osm2pgsql> ${BDD_TEST}
                 WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/bdd)
        message(STATUS "Added test: bdd-${BDD_TEST}")
    endforeach(BDD_TEST)

    set_tests_properties(bdd-regression
                         PROPERTIES FIXTURES_REQUIRED Tablespace)
else()
    message(WARNING "Cannot find behave, BDD tests disabled")
endif()

if (LUA_EXE)
    message(STATUS "Added test: lua-lib")
    add_test(NAME lua-lib COMMAND ${LUA_EXE} lua/tests.lua
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
    set_tests_properties(lua-lib PROPERTIES LABELS NoDB)
else()
    message(WARNING "Can not find Lua interpreter, test 'lua-lib' disabled")
endif()

=== debian/changelog ===
osm2pgsql (2.0.1+ds-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 08 Dec 2024 06:49:45 +0100

osm2pgsql (2.0.1+ds-1) unstable; urgency=medium

  * New upstream release.
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 03 Dec 2024 06:42:17 +0100

osm2pgsql (2.0.0+ds-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 25 Sep 2024 07:15:23 +0200

osm2pgsql (1.11.0+ds-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 18 Feb 2024 09:03:08 +0100

osm2pgsql (1.10.0+ds-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 13 Nov 2023 05:43:51 +0100

osm2pgsql (1.9.2+ds-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 27 Sep 2023 05:20:33 +0200

=== debian/control ===
Source: osm2pgsql
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>,
           David Paleino <dapal@debian.org>,
           Andreas Tille <tille@debian.org>,
           Bas Couwenberg <sebastic@debian.org>
Section: utils
Priority: optional
Build-Depends: architecture-is-64-bit,
               debhelper-compat (= 13),
               cmake,
               dh-python,
               dh-sequence-python3,
               libboost-dev,
               libbz2-dev,
               libcli11-dev,
               libexpat1-dev,
               libopencv-dev,
               libosmium2-dev (>= 2.17.3),
               libpotrace-dev,
               libpq-dev,
               libproj-dev,
               zlib1g-dev,
               liblua5.3-dev,
               lua5.3,
               nlohmann-json3-dev,
               python3,
               python3-argparse-manpage,
               python3-psycopg2,
               python3-pyosmium
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian-gis-team/osm2pgsql
Vcs-Git: https://salsa.debian.org/debian-gis-team/osm2pgsql.git -b bookworm-backports
Homepage: https://osm2pgsql.org/
Rules-Requires-Root: no

Package: osm2pgsql
Architecture: any
Depends: python3-psycopg2,
         python3-pyosmium,
         ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: postgis
Description: OpenStreetMap data to PostgreSQL converter
 Convert OSM planet snapshot data to SQL suitable for loading
 into a PostgreSQL database with PostGIS geospatial extensions. This
 database may then be used to render maps with Mapnik or for other
 geospatial analysis.

## osm2pgsql 2.1.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 
-cmake_minimum_required(VERSION 3.8.0)
-
-project(osm2pgsql VERSION 2.0.1 LANGUAGES CXX C)
+cmake_minimum_required(VERSION 3.10.0)
+
+project(osm2pgsql VERSION 2.1.0 LANGUAGES CXX C)
 
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 
@@ -64,10 +64,10 @@
     set(PostgreSQL_TYPE_INCLUDE_DIR /usr/include)
 endif()
 
-set(MINIMUM_POSTGRESQL_SERVER_VERSION "9.6")
-set(MINIMUM_POSTGRESQL_SERVER_VERSION_NUM "90600")
-
-set(PostgreSQL_ADDITIONAL_VERSIONS "17" "16" "15" "14" "13" "12" "11" "10" "9.6")
+set(MINIMUM_POSTGRESQL_SERVER_VERSION "11")
+set(MINIMUM_POSTGRESQL_SERVER_VERSION_NUM "110000")
+
+set(PostgreSQL_ADDITIONAL_VERSIONS "17" "16" "15" "14" "13" "12" "11")
 
 #############################################################
 # Version
@@ -266,7 +266,6 @@
                 src/gen/gen-tile-sql.cpp
                 src/gen/gen-tile-vector.cpp
                 src/gen/gen-tile.cpp
-                src/gen/params.cpp
                 src/gen/raster.cpp
                 src/gen/tracer.cpp)
     target_link_libraries(osm2pgsql-gen osm2pgsql_lib ${LIBS} ${POTRACE_LIBRARY} ${OpenCV_LIBS})

=== debian/changelog ===
osm2pgsql (2.1.0+ds-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.2, no changes.
  * Update copyright file.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 08 Apr 2025 05:40:21 +0200

## osm2pgsql 2.1.1+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 
 cmake_minimum_required(VERSION 3.10.0)
 
-project(osm2pgsql VERSION 2.1.0 LANGUAGES CXX C)
+project(osm2pgsql VERSION 2.1.1 LANGUAGES CXX C)
 
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

=== man/CMakeLists.txt ===
message(STATUS "Looking for pandoc")
find_program(PANDOC pandoc)
message(STATUS "Looking for argparse-manpage")
find_program(ARGPARSE_MANPAGE argparse-manpage)

set(MANPAGE_TARGETS "")

if(PANDOC)
    message(STATUS "Looking for pandoc - found")
    message(STATUS "  osm2pgsql manual page can be built using 'man' target")
    set(PANDOC_MAN_OPTIONS
        -s
        -t man
        --template ${CMAKE_CURRENT_SOURCE_DIR}/manpage.template
        --variable "version=${PROJECT_VERSION}"
        --variable "title=OSM2PGSQL"
        --variable "section=1"
    )

    add_custom_command(OUTPUT osm2pgsql.1
        COMMAND ${PANDOC} ${PANDOC_MAN_OPTIONS} -o osm2pgsql.1
            ${CMAKE_CURRENT_SOURCE_DIR}/osm2pgsql.md
        DEPENDS osm2pgsql.md manpage.template
        COMMENT "Building manpage osm2pgsql.1"
        VERBATIM)

    list(APPEND MANPAGE_TARGETS osm2pgsql.1)

    if(BUILD_GEN)
        add_custom_command(OUTPUT osm2pgsql-gen.1
            COMMAND ${PANDOC} ${PANDOC_MAN_OPTIONS} -o osm2pgsql-gen.1
                ${CMAKE_CURRENT_SOURCE_DIR}/osm2pgsql-gen.md
            DEPENDS osm2pgsql-gen.md manpage.template
            COMMENT "Building manpage osm2pgsql-gen.1"
            VERBATIM)
        list(APPEND MANPAGE_TARGETS osm2pgsql-gen.1)
    endif()

else()
    message(STATUS "Looking for pandoc - not found")
    message(STATUS "  osm2pgsql manual page can not be built")
endif()

if(ARGPARSE_MANPAGE)
    message(STATUS "Looking for argparse-manpage - found")
    message(STATUS "  osm2pgsql-replication manual page can be built using 'man' target")

    add_custom_command(OUTPUT osm2pgsql-replication.1
        COMMAND python3 ${CMAKE_CURRENT_SOURCE_DIR}/manpage_from_python.py --version ${PROJECT_VERSION} --description "osm2pgsql database updater" ${CMAKE_SOURCE_DIR}/scripts/osm2pgsql-replication > ${CMAKE_CURRENT_BINARY_DIR}/osm2pgsql-replication.1
        DEPENDS ${CMAKE_SOURCE_DIR}/scripts/osm2pgsql-replication manpage_from_python.py
        COMMENT "Building manpage osm2pgsql-replication.1"
        VERBATIM)

    list(APPEND MANPAGE_TARGETS osm2pgsql-replication.1)
else()
    message(STATUS "Looking for argparse-manpage - not found")
    message(STATUS "  osm2pgsql-replication page can not be built")
endif()

if(MANPAGE_TARGETS)
    add_custom_target(man DEPENDS ${MANPAGE_TARGETS} VERBATIM)
endif()

if(ENABLE_INSTALL)
    install(FILES osm2pgsql.1 DESTINATION share/man/man1)
    install(FILES osm2pgsql-replication.1 DESTINATION share/man/man1)
    if (BUILD_GEN)
        install(FILES osm2pgsql-gen.1 DESTINATION share/man/man1)
    endif()
endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -47,6 +47,7 @@
     output-null.cpp
     output-pgsql.cpp
     output.cpp
+    params.cpp
     pgsql-capabilities.cpp
     pgsql-helper.cpp
     pgsql.cpp
@@ -58,6 +59,7 @@
     tagtransform-c.cpp
     tagtransform-lua.cpp
     tagtransform.cpp
+    template.cpp
     thread-pool.cpp
     tile.cpp
     util.cpp

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -44,7 +44,7 @@
 set_test(test-domain-matcher LABELS NoDB)
 set_test(test-expire-from-geometry LABELS NoDB)
 set_test(test-expire-tiles LABELS NoDB)
-set_test(test-flex-indexes)
+set_test(test-flex-indexes LABELS NoDB)
 set_test(test-geom-box LABELS NoDB)
 set_test(test-geom-collections LABELS NoDB)
 set_test(test-geom-linestrings LABELS NoDB)
@@ -58,7 +58,7 @@
 set_test(test-geom-polygons LABELS NoDB)
 set_test(test-geom-transform LABELS NoDB)
 set_test(test-json-writer LABELS NoDB)
-set_test(test-lua-utils)
+set_test(test-lua-utils LABELS NoDB)
 set_test(test-middle)
 set_test(test-node-locations LABELS NoDB)
 set_test(test-options-parse LABELS NoDB)
@@ -86,6 +86,7 @@
 set_test(test-output-pgsql-tablespace LABELS Tablespace)
 set_test(test-output-pgsql-validgeom)
 set_test(test-output-pgsql-z_order)
+set_test(test-params LABELS NoDB)
 set_test(test-persistent-cache LABELS NoDB)
 set_test(test-pgsql)
 set_test(test-pgsql-capabilities)

=== debian/changelog ===
osm2pgsql (2.1.1+ds-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 25 Apr 2025 07:39:42 +0200

osm2pgsql (2.1.1+ds-1) unstable; urgency=medium

  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 14 Apr 2025 15:30:22 +0200

osm2pgsql (2.1.0+ds-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 13 Apr 2025 06:59:25 +0200

=== debian/control ===
--- 
+++ 
@@ -28,7 +28,7 @@
                python3-argparse-manpage,
                python3-psycopg2,
                python3-pyosmium
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/osm2pgsql
 Vcs-Git: https://salsa.debian.org/debian-gis-team/osm2pgsql.git -b bookworm-backports
 Homepage: https://osm2pgsql.org/

## osm2pgsql 2.2.0%2Bds

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -21,6 +21,7 @@
     flex-lua-expire-output.cpp
     flex-lua-geom.cpp
     flex-lua-index.cpp
+    flex-lua-locator.cpp
     flex-lua-table.cpp
     flex-table-column.cpp
     flex-table.cpp
@@ -31,8 +32,10 @@
     geom-functions.cpp
     geom-pole-of-inaccessibility.cpp
     geom.cpp
+    hex.cpp
     idlist.cpp
     input.cpp
+    locator.cpp
     logging.cpp
     lua-setup.cpp
     lua-utils.cpp

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -41,7 +41,6 @@
 set_test(test-check-input LABELS NoDB)
 set_test(test-db-copy-mgr)
 set_test(test-db-copy-thread)
-set_test(test-domain-matcher LABELS NoDB)
 set_test(test-expire-from-geometry LABELS NoDB)
 set_test(test-expire-tiles LABELS NoDB)
 set_test(test-flex-indexes LABELS NoDB)
@@ -57,7 +56,9 @@
 set_test(test-geom-pole-of-inaccessibility LABELS NoDB)
 set_test(test-geom-polygons LABELS NoDB)
 set_test(test-geom-transform LABELS NoDB)
+set_test(test-hex LABELS NoDB)
 set_test(test-json-writer LABELS NoDB)
+set_test(test-locator LABELS NoDB)
 set_test(test-lua-utils LABELS NoDB)
 set_test(test-middle)
 set_test(test-node-locations LABELS NoDB)

=== debian/control ===
--- 
+++ 
@@ -30,7 +30,7 @@
                python3-pyosmium
 Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/osm2pgsql
-Vcs-Git: https://salsa.debian.org/debian-gis-team/osm2pgsql.git -b bookworm-backports
+Vcs-Git: https://salsa.debian.org/debian-gis-team/osm2pgsql.git
 Homepage: https://osm2pgsql.org/
 Rules-Requires-Root: no

## osm2pgsql 2.2.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 
 cmake_minimum_required(VERSION 3.10.0)
 
-project(osm2pgsql VERSION 2.1.1 LANGUAGES CXX C)
+project(osm2pgsql VERSION 2.2.0 LANGUAGES CXX C)
 
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 
@@ -271,6 +271,9 @@
     target_link_libraries(osm2pgsql-gen osm2pgsql_lib ${LIBS} ${POTRACE_LIBRARY} ${OpenCV_LIBS})
 endif()
 
+add_executable(osm2pgsql-expire src/osm2pgsql-expire.cpp)
+target_link_libraries(osm2pgsql-expire osm2pgsql_lib ${LIBS})
+
 #############################################################
 # Optional "clang-tidy" target
 #############################################################
@@ -286,6 +289,7 @@
 
     add_custom_target(clang-tidy
         ${CLANG_TIDY}
+        --config-file ${CMAKE_SOURCE_DIR}/.clang-tidy
         -p ${CMAKE_BINARY_DIR}
         ${CT_CHECK_FILES}
     )

=== man/CMakeLists.txt ===
--- 
+++ 
@@ -25,6 +25,14 @@
         VERBATIM)
 
     list(APPEND MANPAGE_TARGETS osm2pgsql.1)
+
+    add_custom_command(OUTPUT osm2pgsql-expire.1
+        COMMAND ${PANDOC} ${PANDOC_MAN_OPTIONS} -o osm2pgsql-expire.1
+            ${CMAKE_CURRENT_SOURCE_DIR}/osm2pgsql-expire.md
+        DEPENDS osm2pgsql-expire.md manpage.template
+        COMMENT "Building manpage osm2pgsql-expire.1"
+        VERBATIM)
+    list(APPEND MANPAGE_TARGETS osm2pgsql-expire.1)
 
     if(BUILD_GEN)
         add_custom_command(OUTPUT osm2pgsql-gen.1

=== debian/changelog ===
osm2pgsql (2.2.0+ds-1) unstable; urgency=medium

  * New upstream release.
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 21 Sep 2025 13:56:42 -0700

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for osm2pgsql

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Verbose test output
export VERBOSE=1

CFLAGS += $(CPPFLAGS) -DNDEBUG
CXXFLAGS += $(CPPFLAGS) -DNDEBUG

%:
	dh $@ --buildsystem cmake

override_dh_auto_configure:
	dh_auto_configure -- -DEXTERNAL_LIBOSMIUM=ON \
	                     -DEXTERNAL_PROTOZERO=ON \
	                     -DEXTERNAL_CLI11=ON

override_dh_auto_test:
	dh_auto_test || echo "Ignoring test failures"

override_dh_compress:
	# clean up some naive file permissions
	dh_compress -X.php -X.sql -X.js -X.c -X.h

=== debian/watch ===
version=4
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/_/./g;s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)[\-\.]?\d*)$/$1~$2/;s/RC/rc/,\
filenamemangle=s/(?:.*?\/)?(?:rel|v|osm2pgsql)?[\-\_]?(\d\S+)\.(tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))/osm2pgsql-$1.$2/,\
repacksuffix=+ds \
https://github.com/openstreetmap/osm2pgsql/tags \
(?:.*?/archive/(?:.*?/)?)?(?:rel|v|osm2pgsql)?[\-\_]?(\d\S+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
